#! /bin/sh
#
# update.sh - Script to update Packages -file of comic-get repository
# Copyright (C) 2006-2007 Tommi Saviranta <wnd@iki.fi>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#
# Version: update.sh v0.2.0  03-Jan-2007  wnd@iki.fi


echo -n "Identifier: " >Packages_new
cat identifier >>Packages_new
echo "" >>Packages_new
for file in *.rule; do
	pkg=$(sed '/^Package: / !d; s/.*: //' "$file")
	fpkg=$(echo "$file" | cut -d '_' -f 1)
	if test "$pkg" != "$fpkg"; then
		echo "Rulefile \"$file\" defines package \"$pkg\","
		echo "expected \"$fpkg\". Aborting update."
		exit 1
	fi

	flang=$(echo "$file" | cut -d '_' -f 2-3 | cut -d '.' -f 1)
	flclang=$(echo "$flang" | tr [A-Z] [a-z])
	if test "$flang" != "$flclang"; then
		echo "Rulefile \"$file\" has invalid filename."
		echo "Language must be in lowercase. Aborting update."
		exit 1
	fi

	lang=$(sed '/^Language: /!d; s/.*: //' "$file")
	lclang=$(echo $lang | tr [A-Z] [a-z])
	if test "$lclang" != "$flang"; then
		elang1=$(echo $flang | cut -d '_' -f 1)
		elang2=$(echo $flang | cut -d '_' -f 2 | tr [a-z] [A-Z])
		echo "Rulefile \"$file\" defines language \"$lang\","
		echo "expected \"${elang1}_$elang2\". Aborting update."
		exit 1
	fi

	grep -A 999 -- --info-- "$file" | sed '/--info--/ d' >>Packages_new
	echo "" >>Packages_new
done

mv Packages_new Packages
md5sum *.rule >rules.md5sums
md5sum Packages rules.md5sums >md5sums

find . -type f -print0 | xargs -0 chmod 644
chmod 755 src
chmod 700 update.sh
